Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/HiveJobItemTreeView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/HiveJobItemTreeView.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/HiveJobItemTreeView.cs	(revision 6725)
@@ -30,9 +30,9 @@
 
 namespace HeuristicLab.Clients.Hive.Views.ExperimentManager {
-  [View("HiveJob ItemTreeView")]
-  [Content(typeof(ItemCollection<HiveJob>), IsDefaultView = false)]
-  public partial class HiveJobItemTreeView : ItemTreeView<HiveJob> {
-    public new ItemCollection<HiveJob> Content {
-      get { return (ItemCollection<HiveJob>)base.Content; }
+  [View("HiveTask ItemTreeView")]
+  [Content(typeof(ItemCollection<HiveTask>), IsDefaultView = false)]
+  public partial class HiveJobItemTreeView : ItemTreeView<HiveTask> {
+    public new ItemCollection<HiveTask> Content {
+      get { return (ItemCollection<HiveTask>)base.Content; }
       set { base.Content = value; }
     }
@@ -76,7 +76,7 @@
       if (optimizer != null) {
         if (treeView.SelectedNode == null) {
-          Content.Add(new OptimizerHiveJob(optimizer));
+          Content.Add(new OptimizerHiveTask(optimizer));
         } else {
-          var experiment = ((HiveJob)treeView.SelectedNode.Tag).ItemJob.Item as Experiment;
+          var experiment = ((HiveTask)treeView.SelectedNode.Tag).ItemTask.Item as Experiment;
           if (experiment != null) {
             experiment.Optimizers.Add(optimizer);
@@ -88,12 +88,12 @@
     protected override void removeButton_Click(object sender, EventArgs e) {
       if (treeView.SelectedNode != null) {
-        var selectedItem = (HiveJob)treeView.SelectedNode.Tag;
+        var selectedItem = (HiveTask)treeView.SelectedNode.Tag;
         var parentItem = GetParentItem(selectedItem);
         if (parentItem == null) {
-          Content.Remove((HiveJob)treeView.SelectedNode.Tag);
+          Content.Remove((HiveTask)treeView.SelectedNode.Tag);
         } else {
-          var experiment = parentItem.ItemJob.Item as Experiment;
+          var experiment = parentItem.ItemTask.Item as Experiment;
           if (experiment != null) {
-            experiment.Optimizers.Remove(((OptimizerJob)selectedItem.ItemJob).Item);
+            experiment.Optimizers.Remove(((OptimizerTask)selectedItem.ItemTask).Item);
           }
         }
@@ -102,5 +102,5 @@
     #endregion
 
-    protected override ICollection<IItemTreeNodeAction<HiveJob>> GetTreeNodeItemActions(HiveJob selectedItem) {
+    protected override ICollection<IItemTreeNodeAction<HiveTask>> GetTreeNodeItemActions(HiveTask selectedItem) {
       return base.GetTreeNodeItemActions(selectedItem);
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NewExperimentTreeNodeAction.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NewExperimentTreeNodeAction.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NewExperimentTreeNodeAction.cs	(revision 6725)
@@ -25,8 +25,8 @@
 
 namespace HeuristicLab.Clients.Hive {
-  public class NewExperimentTreeNodeAction : IItemTreeNodeAction<HiveJob> {
-    private ItemCollection<HiveJob> hiveJobs;
+  public class NewExperimentTreeNodeAction : IItemTreeNodeAction<HiveTask> {
+    private ItemCollection<HiveTask> hiveJobs;
 
-    public NewExperimentTreeNodeAction(ItemCollection<HiveJob> hiveJobs) {
+    public NewExperimentTreeNodeAction(ItemCollection<HiveTask> hiveJobs) {
       this.hiveJobs = hiveJobs;
     }
@@ -40,10 +40,10 @@
     }
 
-    public void Execute(HiveJob item, HiveJob parentItem) {
+    public void Execute(HiveTask item, HiveTask parentItem) {
       if (item != null) {
-        var experiment = item.ItemJob.Item as Experiment;
+        var experiment = item.ItemTask.Item as Experiment;
         experiment.Optimizers.Add(new Experiment());
       } else {
-        hiveJobs.Add(new OptimizerHiveJob(new Experiment()));
+        hiveJobs.Add(new OptimizerHiveTask(new Experiment()));
       }
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs	(revision 6725)
@@ -0,0 +1,99 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+using HeuristicLab.Hive;
+
+namespace HeuristicLab.Clients.Hive {
+  /// <summary>
+  /// Downloads and deserializes jobs. It avoids too many jobs beeing downloaded or deserialized at the same time to avoid memory problems
+  /// </summary>
+  public class ConcurrentTaskDownloader<T> where T : class, ITask {
+    private bool abort = false;
+    // use semaphore to ensure only few concurrenct connections and few SerializedJob objects in memory
+    private Semaphore downloadSemaphore;
+    private Semaphore deserializeSemaphore;
+
+    public ConcurrentTaskDownloader(int concurrentDownloads, int concurrentDeserializations) {
+      downloadSemaphore = new Semaphore(concurrentDownloads, concurrentDownloads);
+      deserializeSemaphore = new Semaphore(concurrentDeserializations, concurrentDeserializations);
+      TaskScheduler.UnobservedTaskException += new EventHandler<UnobservedTaskExceptionEventArgs>(TaskScheduler_UnobservedTaskException);
+    }
+
+    public void DownloadJob(Task job, Action<Task, T> onFinishedAction) {
+      Task<T> task = Task<TaskData>.Factory.StartNew((x) => DownloadJob(x), job.Id)
+                                     .ContinueWith((x) => DeserializeJob(x.Result));
+      task.ContinueWith((x) => OnJobFinished(job, x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnRanToCompletion);
+      task.ContinueWith((x) => OnJobFailed(job, x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnFaulted);
+    }
+
+    private void OnJobFinished(Task job, Task<T> task, Action<Task, T> onFinishedAction) {
+      onFinishedAction(job, task.Result);
+    }
+    private void OnJobFailed(Task job, Task<T> task, Action<Task, T> onFinishedAction) {
+      task.Exception.Flatten().Handle((e) => { return true; });
+      OnExceptionOccured(task.Exception.Flatten());
+      onFinishedAction(job, null);
+    }
+
+    protected TaskData DownloadJob(object jobId) {
+      downloadSemaphore.WaitOne();
+      deserializeSemaphore.WaitOne();
+      TaskData result;
+      try {
+        if (abort) return null;
+        result = ServiceLocator.Instance.CallHiveService(s => s.GetJobData((Guid)jobId));
+      }
+      finally {
+        downloadSemaphore.Release();
+      }
+      return result;
+    }
+
+    protected T DeserializeJob(TaskData jobData) {
+      try {
+        if (abort || jobData == null) return null;
+        Task job = ServiceLocator.Instance.CallHiveService(s => s.GetJob(jobData.TaskId));
+        if (job == null) return null;
+        var deserializedJob = PersistenceUtil.Deserialize<T>(jobData.Data);
+        jobData.Data = null; // reduce memory consumption.
+        return deserializedJob;
+      }
+      finally {
+        deserializeSemaphore.Release();
+      }
+    }
+
+    private void TaskScheduler_UnobservedTaskException(object sender, UnobservedTaskExceptionEventArgs e) {
+      e.SetObserved(); // avoid crash of process because task crashes. first exception found is handled in Results property
+      OnExceptionOccured(new HiveException("Unobserved Exception in ConcurrentTaskDownloader", e.Exception));
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception exception) {
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(exception));
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs	(revision 6725)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive {
+  public class ConcurrentTaskDownloaderException : Exception {
+    public ConcurrentTaskDownloaderException(string message, Exception innerException)
+      : base(message, innerException) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs	(revision 6725)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive {
+  class AddTaskToHiveException : Exception {
+    public AddTaskToHiveException(string message) : base(message) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs	(revision 6725)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive {
+  class TaskResultPollingException : Exception {
+    public TaskResultPollingException(string message) : base(message) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 6725)
@@ -113,6 +113,6 @@
   <ItemGroup>
     <Compile Include="HiveClient.cs" />
-    <Compile Include="Jobs\ItemJob.cs" />
-    <Compile Include="RefreshableHiveExperiment.cs" />
+    <Compile Include="Tasks\ItemTask.cs" />
+    <Compile Include="RefreshableJob.cs" />
     <Compile Include="ServiceClients\HiveExperimentPermission.cs" />
     <Compile Include="StateLogList.cs" />
@@ -122,23 +122,23 @@
     <None Include="app.config" />
     <None Include="HeuristicLabClientsHivePlugin.cs.frame" />
-    <Compile Include="Exceptions\AddJobToHiveException.cs" />
-    <Compile Include="Exceptions\JobResultPollingException.cs" />
+    <Compile Include="Exceptions\AddTaskToHiveException.cs" />
+    <Compile Include="Exceptions\TaskResultPollingException.cs" />
     <Compile Include="Exceptions\OptimizerNotFoundException.cs" />
-    <Compile Include="ConcurrentJobDownloader.cs" />
-    <Compile Include="HiveJobs\EngineHiveJob.cs" />
+    <Compile Include="ConcurrentTaskDownloader.cs" />
+    <Compile Include="HiveJobs\EngineHiveTask.cs" />
     <Compile Include="Exceptions\HiveException.cs" />
-    <Compile Include="HiveJobDownloader.cs" />
-    <Compile Include="ConcurrentJobDownloaderException.cs" />
+    <Compile Include="TaskDownloader.cs" />
+    <Compile Include="ConcurrentTaskDownloaderException.cs" />
     <Compile Include="TreeView\IItemTree.cs" />
     <Compile Include="TreeView\IItemTreeAction.cs" />
-    <Compile Include="HiveJobs\OptimizerHiveJob.cs">
+    <Compile Include="HiveJobs\OptimizerHiveTask.cs">
       <SubType>Code</SubType>
     </Compile>
     <Compile Include="Exceptions\ResourceNotFoundException.cs" />
     <Compile Include="IServiceLocator.cs" />
-    <Compile Include="Jobs\EngineJob.cs" />
-    <Compile Include="Jobs\OptimizerJob.cs" />
+    <Compile Include="Tasks\EngineTask.cs" />
+    <Compile Include="Tasks\OptimizerTask.cs" />
     <Compile Include="HeuristicLabClientsHivePlugin.cs" />
-    <Compile Include="HiveJobs\HiveJob.cs" />
+    <Compile Include="HiveJobs\HiveTask.cs" />
     <Compile Include="JobResultPoller.cs" />
     <Compile Include="Util\PersistenceUtil.cs" />
